#include <bc_key_scan.h>

#include <bc_led_disp.h>

#include <SoftwareSerial.h>

SoftwareSerial swSerial(11, 12);  // rx, tx
BcLedDisp Disp(swSerial);   // 建立显示驱动实例
BcKeyScan Keypad(swSerial); // 建立键盘驱动实例

unsigned char KeyValue;

void setup() {
  // put your setup code here, to run once:
  swSerial.begin(9600);   // 软件串口初始化
  Disp.clear();   // 清除显示
  Disp.sendCmd(BLINK_SPEED, 25);    // 设定闪烁速度
  Disp.digitBlink(0, 1);    // 第0位闪烁显示
  Disp.sendCmd(DIRECT_WT+0, 0x08);  // 第0位上使用直接写显示寄存器的方式显示特殊字符下划线'_'
}

void loop() {
  // put your main code here, to run repeatedly:
  Keypad.checkChanges();    // 更新键盘状态
  if (Keypad.isKeyChanged()) {    // 检查是否有新按键
    KeyValue = Keypad.getKeyValue();    // 如果有新按键，获取键值
    Disp.digitBlink(0, 0);    // 第0位停止闪烁
    if (KeyValue <= 15) {     // 如果键值小于等于15
      Disp.displayHex(KeyValue, 0, 1);    // 直接按16进制显示键值
    }
    else {    // 如果键值大于15
      switch (KeyValue) {
        case 16:    // 如果是16键显示‘P’
          Disp.sendCmd(DIRECT_WT+0, 0x73);  // 'P'
          break;
        case 17:    // 如果是17键显示'H'
          Disp.sendCmd(DIRECT_WT+0, 0x76);  // 'H'
          break;
        case 18:    // 如果是18键显示'L'
          Disp.sendCmd(DIRECT_WT+0, 0x38);  // 'L'
          break;
        case 19:    // 如果是19键显示空格
          Disp.sendCmd(DIRECT_WT+0, 0x00);  // ' '
          break;
        default:
          break;
      }
    }
    delay(100);   // 保持显示100ms
    Disp.sendCmd(SHIFT_H_WT+0, 0x08);   // 第0位插入下划线，同时显示左移
    Disp.digitBlink(0, 1);    // 第0位恢复闪烁显示
  }
}
